/*
 * ¤allocator
 * Ǥatorά뤳Ȥ
 */
#ifndef _alloc_h_included_
#define _alloc_h_included_

#ifdef __cplusplus
extern "C" {
#endif

/** Υϥɥ */
typedef struct allocator_priv * allocator;

/*
 * allocator
 * s: ¤Τsize(Хȿ)
 * dtor: =destructor ݤ֥ȤȤ˸ƤФؿ
 *  dtorΰϲ륪֥
 * ֤: allocator
 */
allocator anthy_create_allocator(int s, void (*dtor)(void *));

/*
 * allocator
 *  κݤˡallocatorݤ줿֥ȤƲ
 * a: allocator
 */
void anthy_free_allocator(allocator a);

/*
 * ֥Ȥݤ
 * a: allocator
 * ֤: ݤ֥ȤΥɥ쥹
 */
void *anthy_smalloc(allocator a);
/*
 * ֥Ȥ
 * a: allocator
 * p: 륪֥ȤΥɥ쥹
 */
void anthy_sfree(allocator a, void *p);

/* Ƥallocator˴ */
void anthy_quit_allocator(void);



#if 0	/* Patched by G-HAL, Mon,13 Oct,2008 */
#include <stdio.h>

#define	malloc_check(s)	\
		malloc(s); fprintf(stderr, "malloc: %s:%d: %zd\n", __FILE__, __LINE__, s )

#define	realloc_check(p,s)	\
		realloc(p,s); fprintf(stderr, "realloc: %s:%d: %zd\n", __FILE__, __LINE__, s )

#define	free_check(p)	\
		free(p); fprintf(stderr, "free: %s:%d:\n", __FILE__, __LINE__ )
#endif

#ifdef __cplusplus
}
#endif

#endif
