/* segment(ʸ)  */
#ifndef _segment_h_included_
#define _segment_h_included_

#if 1	/* Patched by G-HAL, Tue,20 Oct,2009 */
#if !defined(__STDC_LIMIT_MACROS)
# define        __STDC_LIMIT_MACROS
#endif
#include <stdint.h>
#endif
#include <anthy/segclass.h>
#include <anthy/wtype.h>
#include <anthy/xstr.h>
#include <anthy/dic.h>

#ifdef __cplusplus
extern "C" {
#endif

/** ι */
struct cand_elm {
  int nth; /* -1ΤȤϼ񤫤γƤäƤʤ */
  wtype_t wt;
  seq_ent_t se;
  int ratio;/* ٤ɾݤ˻ѤΨ */
  xstr str;/* Ѵоݤʸ */
  int id;/* Ѵ̤ʸФhash */
  uint32_t	uc_id_tmp;	/**< 㼭񸡺ѤΥϥå, Patched by G-HAL, Tue,20 Oct,2009 */
};

/** Ĥθ롣
 * anthy_release_cand_ent()ǲ
 */
struct cand_ent {
  /** δܥ, Patched by G-HAL, Mon,13 Jul,2009 */
  int score_base;
  /** β, Patched by G-HAL, Sat,10 Oct,2009 */
  int score_tentative;
  /** Υ */
  int score;
  /** Ѵʸ */
  xstr str;
  /** Ǥο */
  int nr_words;
  /** Ǥ */
  struct cand_elm *elm;
  /** ΩΥǥå */
  int core_elm_index;
  /** °hash */
  int dep_word_hash;
  /** Υե饰 CEF_? */
  unsigned int flag;
  struct meta_word *mw;
};

/* (cand_ent)Υե饰 */
#define CEF_NONE                                 0
#define CEF_SINGLEWORD                  0x00000002
#define CEF_HIRAGANA                    0x00000004
#define CEF_KATAKANA                    0x00000008
#define CEF_GUESS                       0x00000010
#define CEF_USEDICT                     0x00000020
#define CEF_COMPOUND                    0x00000040
#define CEF_COMPOUND_PART               0x00000080
#define CEF_BEST                        0x00000100
#define CEF_CONTEXT                     0x00000200
#define CEF_GUESS_KATAcoreHIRAdep       0x00000400	/* Added by G-HAL, Tue,13 Jan,2009 */
#define CEF_GUESS_XCT_PART              0x00000800	/* Added by G-HAL, Tue,19 May,2009 */
#define CEF_AddScoreByOCHAIRE           0x00001000	/* Added by G-HAL, Wed,14 Jan,2009 */
#define CEF_AddScoreByCANDHISTORY       0x00002000	/* Added by G-HAL, Wed,14 Jan,2009 */
#define CEF_AddScoreByLEARNstrong       (CEF_AddScoreByOCHAIRE | CEF_AddScoreByCANDHISTORY)	/* Added by G-HAL, Wed,14 Jan,2009 */
#define CEF_AddScoreByHISTORYweak       0x00004000	/* Added by G-HAL, Wed,14 Jan,2009 */
#define CEF_AddScoreByLEARN             0x0000F000	/* Added by G-HAL, Wed,14 Jan,2009 */
#define CEF_TUNESCORE                   0x000F0000	/* ʸṽ¤˲롣Added by G-HAL, Thu,27 Nov,2008 */
#define CEF_TUNESCORE_SIGN              0x00080000	/* DEF_TUNE_SCORE ӥåȡAdded by G-HAL, Thu,27 Nov,2008 */
#define CEF_TUNESCORE_NUM               0x00070000	/* DEF_TUNE_SCORE οͥӥåȡAdded by G-HAL, Thu,27 Nov,2008 */
#define CEF_TUNESCORE_CLOUMN            0x00010000	/* DEF_TUNE_SCORE γϥӥåȡAdded by G-HAL, Thu,27 Nov,2008 */
#define CEF_OCHAIRE                     0x00100000	/* OCHAIREͳʸᡣModified by G-HAL, Thu,27 Nov,2008 */
#define CEF_OCHAIREwithDEP              0x00200000	/* °դOCHAIREͳʸᡣAdded by G-HAL, Sat,24 Jan,2009 */
#define CEF_OCHAIREwithINDEP            0x00400000	/* ΩդOCHAIREͳʸᡣAdded by G-HAL, Sun,08 Feb,2009 */
#define CEF_CANDHISTORY                 0x00800000	/* CAND_HISTORYͳʸᡣAdded by G-HAL, Fri,14 Nov,2008 */
#define CEF_ORIGIN_IS_LEARN             0x00F00000	/* ؽͳʸᡣAdded by G-HAL, Tue,02 Dec,2008 */
#define CEF_SPECIAL_EVAL_SCORE          0x00F0F1E0	/* üʥûԤäƤե饰¡Added by G-HAL, Sun,25 Oct,2009 */
#define CEF_DONTLEARN_EXPANDPAIR        0x01000000	/* Ǥޤ EXPANDPAIR ؽʤ Patched by G-HAL, Thu,27 Nov,2008 */
#define CEF_DONTLEARN_INDEP_HISTORY     0x04000000	/* Ǥޤ INDEPPAIR/INDEP_HISTORY ؽʤ Patched by G-HAL, Tue,04 Nov,2008, Tue,13 Jan,2009 */
#define CEF_DONTLEARN_DEP_HISTORY       0x08000000	/* Ǥޤ DEP_HISTORY ؽʤ Patched by G-HAL, Tue,03 Feb,2009 */
#define CEF_DONTLEARN_PREDICTION        0x10000000	/* Ǥޤ PREDICTION ؽʤ Patched by G-HAL, Tue,04 Nov,2008 */
#define CEF_DONTLEARN_CANDHISTORY       0x20000000	/* Ǥޤ CAND_HISTORY ؽʤ Patched by G-HAL, Tue,04 Nov,2008 */
#define CEF_DONTLEARN_OCHAIRE_IFONLYITS 0x40000000	/* ǤǹƤ OCHAIRE ؽʤ Patched by G-HAL, Sun,02 Nov,2008 */
#define CEF_DONTLEARN_OCHAIRE_IFHAVEIT  0x80000000	/* Ǥޤ OCHAIRE ؽʤ Patched by G-HAL, Sun,02 Nov,2008 */
#define CEF_DONTLEARN_ALL               0xFF000000	/* Ǥޤϰڳؽʤ Patched by G-HAL, Tue,04 Nov,2008 */

/** Context¸ߤʸ
 * release_seg_entǲ
 */
struct seg_ent {
  /* strμΤcontextˤ */
  xstr str;
  /* commit줿ֹ桢οξϤޤߥåȤƤʤ */
  int committed;
  /** ꤵ줿ֹ桢οξϤޤ̤ Patched by G-HAL, Sat,25 Jul,2009 */
  int provisional_committed;

  /*  */
  int nr_cands;/* ο */
  struct cand_ent **cands;/*  */

  int from, len;/* len == str.len */

  /* ʸι */
  int nr_metaword;
  struct meta_word **mw_array;

  /* Ӥɤä饹 */
  enum seg_class best_seg_class;
  /* Ӥɤämeta_word
   * mw_arrayˤ⡢ޤޤ뤳ȤԤǤ뤬ݾڤϤʤ */
  struct meta_word *best_mw;

  struct seg_ent *prev, *next;
};

/** ʸΥꥹ */
struct segment_list {
  int nr_segments;
  struct seg_ent list_head;
};

/* (̵̤Ƥޤä) */
void anthy_release_cand_ent(struct cand_ent *s);

/**/
struct seg_ent *anthy_get_nth_segment(struct segment_list *c, int );
void anthy_print_candidate(struct cand_ent *ce);

/* compose.c */
/* Ф */
struct splitter_context;
void anthy_do_make_candidates(struct splitter_context *sc,
			      struct seg_ent *e, int is_reverse);

#ifdef __cplusplus
}
#endif

#endif
