/*
 * AnthyǻȤʸ
 * ä˼ä褦ȤƤ櫓Ǥ̵Τǡ
 * ˤؿλѤ϶ʤ
 */
#ifndef _xstr_h_included_
#define _xstr_h_included_

#if 1	/* Patched by G-HAL, Tue,20 Oct,2009 */
#if !defined(__STDC_LIMIT_MACROS)
# define        __STDC_LIMIT_MACROS
#endif
#include <stdint.h>
#endif
#include "anthy/anthy.h"	/* Patched by G-HAL, Mon,08 Jun,2009 */

#ifdef __cplusplus
extern "C" {
#endif

#if 1	/* Patched by G-HAL, Sun,07 Jun,2009, Wed,10 Jun,2009 */
# define	MAX_BYTES_PER_XCHAR	6
# define	MAX_BYTES_BASE	8
	/* UTF-8  4(ʸ)+1(NUL)
	 * EUC-JP  3(ʸ)+1(NUL)
	 * EUC  4(ʸ)+1(NUL)
	 * ISO-2022  4(SI)+2(ʸ)+3(SO)+1(NUL)
	 */
#endif


/** ʸ
 * UCS4äƤ */
typedef int xchar;

/** ʸ
 * xstrtypedefƤ
 */
typedef struct xstr_ {
  /** ʸؤΥݥ */
  xchar *str;
  /** xcharο */
  int len;
} xstr;

#if !defined(USE_ICONV)	/* Patched by G-HAL, Sun,07 Jun,2009 */
/* ǥХåѤνϴؿ */
void anthy_putxchar(xchar );
void anthy_putxstr(xstr *);
void anthy_putxstrln(xstr *);

/* Cʸؤν񤭽Ф */
int anthy_sputxchar(char *, xchar , int encoding);
int anthy_sputxstr(char *, xstr *, int encoding);
int anthy_snputxstr(char *, int , xstr *, int encoding);

/* xstrstrmalloc롢freeξ뤫anthy_free_xstrǲ */
xstr *anthy_cstr_to_xstr(const char *, int );
/* ̤mallocǳݤ */
char *anthy_xstr_to_cstr(xstr *, int);
#endif

/* xstrstrmalloc */
#if 0	/* Patched by G-HAL, Tue,20 Oct,2009 */
xstr *anthy_xstr_dup(xstr *);
#else
xstr* anthy_xstr_dup( const xstr* const s );
#endif
void anthy_free_xstr(xstr *);

/* ̤mallocǳݤ */
xchar *anthy_xstr_dup_str( const xstr* const );
void anthy_free_xstr_str(xstr *);

/* ʸ򥳥ԡ */
xstr* anthy_xstrcpy(xstr *, xstr *);
/* ʸӤ롣strcmpƱư(֤ͤ˰̣) */
int anthy_xstrcmp( const xstr*, const xstr* );
/* nʸܤޤʸӤ롣strncmpƱư(֤ͤ˰̣) */
int anthy_xstrncmp(xstr *, xstr *, int);
/* s->strrealloc */
xstr *anthy_xstrcat(xstr *s, xstr *d);
/* xs->strrealloc */
xstr *anthy_xstrappend(xstr *xs, xchar c);

/** xs  UCS-2 ΤߤǹƤ뤫ݤ򸡺, Patched by G-HAL, Mon,20 Oct,2008 */
extern int anthy_xstr_is_ucs2( const xstr* const xs );

/* strtollxstr */
long long anthy_xstrtoll(xstr *);
/* ѿȾѿؤѴ */
xstr *anthy_xstr_wide_num_to_num(xstr *);
/* Ҥ餬ʤ饫ʤؤѴʡ֤פϡ֥פѴ */
xstr *anthy_xstr_hira_to_kata(xstr *);
#if 1	/* Patched by G-HAL, Sun,19 Apr,2009 */
extern xstr* const anthy_xstr_hira_to_kata_without_vu( const xstr* const src_xs );
extern xstr* const anthy_xstr_kata_to_hira( const xstr* const src_xs );
extern xstr* const anthy_xstr_vu_to_uddot( const xstr* const src_xs );
extern xstr* const anthy_xstr_vu_to_hirauddot( const xstr* const src_xs );
#endif
/**/
xstr *anthy_xstr_hira_to_half_kata(xstr *);
xstr *anthy_conv_half_wide(xstr *xs);

#if 0		/* Patched by G-HAL, Tue,19 May,2009 */
/*  xcharη */
#define XCT_ALL 0xffffffff
#define XCT_NONE 0
#define XCT_HIRA 1
#define XCT_KATA 2
#define XCT_ASCII 4
#define XCT_NUM 8
#define XCT_WIDENUM 16
#define XCT_OPEN 32
#define XCT_CLOSE 64
/* ľʸΰ */
#define XCT_PART 128
/*  */
#define XCT_DEP 256
/*  */
#define XCT_SYMBOL 1024
/*  */
#define XCT_KANJI 2048
/*  */
#define XCT_PUNCTUATION 4096
#else
/*  xcharη */
enum XCT_t {
  XCT_ALL         = 0x1FFFFFFFUL,
  XCT_NONE        = 0x00000000UL,
  XCT_HIRA        = 0x00000001UL,	/**< ʿ̾ */
  XCT_KATA        = 0x00000002UL,	/**<  */
  XCT_KANA_LSB    = 0x01000000UL,	/**< XCT_KANA_* κǲ̥ӥåȡӥåȥեȤ XCT_PART_* Ȥ黻ԤΤǥӥåȤν֤ա */
  XCT_KANA_MASK   = 0x1F000000UL,	/**< XCT_KANA_* Υޥ */
  XCT_KANA_A      = 0x01000000UL,	/**< XCT_HIRA Τ */
  XCT_KANA_I      = 0x02000000UL,	/**< XCT_HIRA Τ */
  XCT_KANA_U      = 0x04000000UL,	/**< XCT_HIRA Τ */
  XCT_KANA_E      = 0x08000000UL,	/**< XCT_HIRA Τ */
  XCT_KANA_O      = 0x10000000UL,	/**< XCT_HIRA Τ */
  XCT_ASCII       = 0x00000004UL,	/**< ѿ */
  XCT_NUM         = 0x00000008UL,	/**< JIS X 0201  */
  XCT_WIDENUM     = 0x00000010UL,	/**< JIS X 0201 ʳο */
  XCT_OPEN        = 0x00000020UL,	/**<  */
  XCT_CLOSE       = 0x00000040UL,	/**< Ĥ */
  XCT_PART        = 0x00000080UL,	/**< ٹ */
  XCT_PART_LSB    = 0x00010000UL,	/**< XCT_PART_* κǲ̥ӥåȡӥåȥեȤ XCT_KANA_* Ȥ黻ԤΤǥӥåȤν֤ա */
  XCT_PART_MASK   = 0x001F0000UL,	/**< XCT_PART_* Υޥ */
  XCT_PART_A      = 0x00010000UL,	/**< XCT_PART ΤʤͥŪϢ뤹 */
  XCT_PART_I      = 0x00020000UL,	/**< XCT_PART ΤʤͥŪϢ뤹 */
  XCT_PART_U      = 0x00040000UL,	/**< XCT_PART ΤʤͥŪϢ뤹 */
  XCT_PART_E      = 0x00080000UL,	/**< XCT_PART ΤʤͥŪϢ뤹 */
  XCT_PART_O      = 0x00100000UL,	/**< XCT_PART ΤʤͥŪϢ뤹 */
  XCT_DEP         = 0x00000100UL,	/**< ʸǽȤʤꤦʿ̾ */
  XCT_SYMBOL      = 0x00000400UL,	/**<  */
  XCT_KANJI       = 0x00000800UL,	/**<  */
  XCT_PUNCTUATION = 0x00001000UL,	/**<  */
  XCT_chgHIRAKATA = 0x00002000UL,	/**< ʿ̾ʤؤѴǽ */
  XCT_chgHALFFULL = 0x00004000UL,	/**< Half-Width  Full-Width ؤѴǽ */
  XCT_toHALFKANA  = 0x00008000UL,	/**< Half-Width ʤؤѴǽ */
  XCT_DONTLEARN   = 0x00000200UL,	/**< ؽʤʸ */
};
#endif

#if 0		/* Patched by G-HAL, Tue,19 May,2009 */
/** XCT_*֤äƤ */
int anthy_get_xchar_type(const xchar );
/** ƤʸФXCT_*ѤȤä */
int anthy_get_xstr_type(const xstr *);
#else
extern enum XCT_t anthy_get_xchar_type( const xchar xc );
# if !defined(USE_ICONV)	/* Patched by G-HAL, Sun,14 Jun,2009 */
extern enum XCT_t anthy_get_xchar_type50( const xchar xc );
# endif
extern enum XCT_t anthy_get_xstr_type( const xstr* const xs );
#endif

/* hash */
#if 0	/* Patched by G-HAL, Tue,20 Oct,2009, Sun,01 Nov,2009, Sat,07 Nov,2009 */
int anthy_xstr_hash(xstr *);
#else
extern uint32_t anthy_hash_uint8_update( uint32_t hash, uint8_t d );
extern uint32_t anthy_hash_uint32_update( uint32_t hash, uint32_t d );
extern uint32_t anthy_hash_str_start( const char* const s );
extern uint32_t anthy_hash_str_update( uint32_t hash, const char* const s );
extern uint32_t anthy_hash_xstr_start( const xstr* const xs );
extern uint32_t anthy_hash_xstr_update( uint32_t hash, const xstr* const xs );
extern int anthy_hash_finalize( uint32_t hash );
extern int anthy_xstr_hash( const xstr* const xs );
#endif

/* xstr.c */
int anthy_init_xstr(void);
void anthy_quit_xstr(void);
void anthy_xstr_set_print_encoding(int );

#if !defined(USE_ICONV)	/* Patched by G-HAL, Sun,24 May,2009 - Mon,25 May,2009, Sun,07 Jun,2009 - Tue,09 Jun,2009 */
int anthy_euc_to_ucs(int ec);
int anthy_ucs_to_euc(int uc);

const char *anthy_utf8_to_ucs4_xchar(const char *s, xchar *res);

/**/
char *anthy_conv_euc_to_utf8(const char *s);
char *anthy_conv_utf8_to_euc(const char *s);
#else
#endif

#if defined(USE_ICONV)	/* Patched by G-HAL, Sun,07 Jun,2009 - Tue,09 Jun,2009 */

/* xstr.c */
extern void anthy_putxchar( xchar xc );
extern void anthy_putxstr( xstr* const xs );
extern void anthy_putxstrln( xstr* const xs );

/* anthy_iconv.c */
extern const char* anthy_utf8_to_ucs4_xchar( const char* const s, xchar* const res );
extern int anthy_snputcstr( xstr* const xs, int n, const char* const buf, enum ANTHY_ENCODING from_encoding );
extern int anthy_snputxstr( char* const buf, int n, const xstr* const xs, enum ANTHY_ENCODING to_encoding );

extern char* const anthy_conv_euc_to_utf8( const char* const s );
extern char* const anthy_conv_utf8_to_euc( const char* const s );
extern xstr* const anthy_cstr_to_xstr( const char* const c, enum ANTHY_ENCODING from_encoding );
extern char* const anthy_xstr_to_cstr( const xstr* const s, enum ANTHY_ENCODING to_encoding );

extern int anthy_init_iconv( void );
extern int anthy_open_iconv( enum ANTHY_ENCODING encoding );
extern int anthy_isuseable_iconv( enum ANTHY_ENCODING encoding );
extern int anthy_open_iconv_userdefineencoding( const char* const encoding_name );
extern int anthy_quit_iconv( void );
#endif

#ifdef __cplusplus
}
#endif

#endif
