/*
 * θ򴹤Υҥȥ롣
 *
 * anthy_swap_cand_ent() ǳؽ
 * anthy_proc_swap_candidate() ǳؽ̤Ѥ
 *
 *  üפȤȥåפ˽ФơȪפǳꤵ줿
 *  Ω:ü->Ȫ
 *    ĤΥȥɲä
 *
 */
#if defined(HAVE_CONFIG_H)	/* Patched by G-HAL */
# include "config.h"
#endif

#include <stdlib.h>

#include "anthy/settings.h"		/* Patched by G-HAL, Fri,17 Oct,2008 */
#include <anthy/record.h>
#include <anthy/segment.h>
/* for OCHAIRE_SCORE */
#include <anthy/splitter.h>
#include "sorter.h"
#include "src-worddic/exception_word_list.h"	/* Patched by G-HAL, Sat,01 Nov,2008 */

/* #define MAX_INDEP_PAIR_ENTRY 4096*/	/* Patched by G-HAL, Thu,13 Sep,2007. original: 100, Ω INDEPPAIR γؽξ */

/* μΩؽ */
static void
learn_swap_cand_indep(struct cand_ent *o, struct cand_ent *n)
{
 #if 0		/* Patched by G-HAL, Sat,23 Aug,2008, Fri,17 Oct,2008, Sat,01 Nov,2008, Tue,02 Dec,2008, Wed,03 Dec,2008, Fri,26 Jun,2009 */
  xstr os, ns;
  int res;
  int o_idx = o->core_elm_index;
  int n_idx = n->core_elm_index;

  /* Ωޤʸᤷؽʤ */
  if (o_idx < 0 || n_idx < 0) {
    return ;
  }
  if (o->elm[o_idx].str.len != n->elm[n_idx].str.len) {
    return ;
  }
  if (o->elm[o_idx].nth == -1 || n->elm[n_idx].nth == -1) {
    return ;
  }
  res = anthy_get_nth_dic_ent_str(o->elm[o_idx].se, &o->elm[o_idx].str,
				  o->elm[o_idx].nth, &os);
  if (res) {
    return ;
  }
  res = anthy_get_nth_dic_ent_str(n->elm[n_idx].se, &n->elm[n_idx].str,
				  n->elm[n_idx].nth, &ns);
  if (res) {
    free(os.str);
    return ;
  }
  if (anthy_select_section("INDEPPAIR", 1) == 0) {
    if (anthy_select_row(&os, 1) == 0) {
      anthy_set_nth_xstr(0, &ns);
    }
  }
  free(os.str);
  free(ns.str);
 #else
  xstr os = { NULL, 0 };
  xstr ns = { NULL, 0 };
  int o_idx = o->core_elm_index;
  int n_idx = n->core_elm_index;
  int res;

  do {

    if (0 != anthy_select_section(INDEPPAIR, 1)) {
      break;
    }

    /* Ωޤʸᤷؽʤ */
    if (n_idx < 0) {
      /* ʼΩ̵ */
      break;
    }
    if (n->elm[n_idx].nth < 0) {
      /* Ω줬Ĥʤ */
      break;
    }
    res = anthy_get_nth_dic_ent_str( n->elm[n_idx].se, &n->elm[n_idx].str, n->elm[n_idx].nth, &ns );
    if (res || (NULL == ns.str) || (ns.len <= 0)) {
      break;
    }

    /* 롼פκϿѤ򤷤ΤǴϤ˺פĤƤ */
    if (0 == anthy_select_row_with_learn(&ns,0,0)){
      anthy_set_nth_xstr(0, &ns);
      anthy_mark_row_used();
    }

    /* ؽե饰Υå */
    if (CEF_DONTLEARN_INDEP_HISTORY & n->flag) {
      break;
    }

    /* Ωޤʸᤷؽʤ */
    if (o_idx < 0) {
      /* ʼΩ̵ */
      break;
    }
    if (o->elm[o_idx].nth < 0) {
      /* Ω줬Ĥʤ */
      break;
    }
    /* ΩɤߤĹפʤ */
    if (o->elm[o_idx].str.len != n->elm[n_idx].str.len) {
      break;
    }
    res = anthy_get_nth_dic_ent_str( o->elm[o_idx].se, &o->elm[o_idx].str, o->elm[o_idx].nth, &os );
    if (res || (NULL == os.str) || (os.len <= 0)) {
      break;
    }
    if (anthy_settings.anthy_mode.extra_flag.exception_word.indep_history
	&& anthy_ishit_exception_word(&os)) {
      break;
    }

    /* Commit */
    if (0 == anthy_select_row_with_learn(&os,1,0)) {
      anthy_set_nth_xstr(0, &ns);
      anthy_mark_row_used();
    }

  } while (0);

  if (os.str) {
    free(os.str);
  }
  if (ns.str) {
    free(ns.str);
  }
  return;
 #endif
}

/*
 * o Фn ߥåȤ줿Τ
 * o -> n record˥åȤ
 */
void
anthy_swap_cand_ent(struct cand_ent *o, struct cand_ent *n)
{
  if (o == n) {
    /* Ʊ */
   #if 1	/* η̤ȿγؽκ, Patched by G-HAL, Tue,02 Dec,2008 */
    int n_idx = n->core_elm_index;
    if ((0 <= n_idx) && (0 <= n->elm[n_idx].nth)) {
      xstr ns;
      const int res = anthy_get_nth_dic_ent_str( n->elm[n_idx].se, &n->elm[n_idx].str, n->elm[n_idx].nth, &ns );
      if (0 == res) {
	if (0 == anthy_select_section(INDEPPAIR, 1)) {
	  if (0 == anthy_select_row_with_learn(&ns,0,0)){
	    /* ϿѤ򤷤ΤǴϤ˺פĤƤ */
	    anthy_set_nth_xstr(0, &ns);
	    anthy_mark_row_used();
	  }
	}
      }
      free(ns.str);
    }
   #endif
    return ;
  }
  if (n->flag & CEF_USEDICT) {
    /* 㼭񤫤ФƤ */
    return ;
  }
  /* Ω */
  learn_swap_cand_indep(o, n);
}


/*
 * Ѵ¤٤֤Ǻͥθ
 * 롼פνʤɤԤ
 */
static xstr *
prepare_swap_candidate(xstr *target)
{
  xstr *xs, *n;
  if (anthy_select_row(target, 0) == -1) {
    return NULL;
  }
  xs = anthy_get_nth_xstr(0);
  if (!xs) {
    return NULL;
  }
  /*  -> xs ȤʤΤȯ */
  /* anthy_mark_row_used();*/	/* Don't learn INDEPPAIR in the middle of conversion. Patched by G-HAL, Thu,21 Aug,2008 */
  if (0 == anthy_xstrcmp(target,xs)) {	/* Patched by G-HAL, Tue,02 Dec,2008 */
    return NULL;
  }
  if (anthy_select_row(xs, 0) != 0){
    /* xs ->  */
    return xs;
  }
  /* xs -> n */
  n = anthy_get_nth_xstr(0);
  if (!n) {
    return NULL;
  }
  if (0 == anthy_xstrcmp(xs,n)) {	/* Patched by G-HAL, Wed,03 Dec,2008 */
    return xs;
  }

  if (!anthy_xstrcmp(target, n)) {
    /*  -> xs -> n  n = Υ롼 */
   #if 0	/* Patched by G-HAL, Tue,02 Dec,2008 */
    anthy_select_row(target, 0);
    anthy_release_row();
    anthy_select_row(xs, 0);
    anthy_release_row();
   #else
    if (0 == anthy_select_row(target, 0)){
      /* 롼פκϿѤ򤷤ΤǴϤ˺פĤƤ */
      anthy_set_nth_xstr(0, target);
    }
   #endif
    /*  -> xs äơ򴹤ɬפ̵ */
    return NULL;
  }
  /*  -> xs -> n  n != ʤΤ
   *  -> n
   */
  if (anthy_select_row(target, 0) == 0){
    anthy_set_nth_xstr(0, n);
    /* ϢƤǡñ㲽ʤΤǡäΤϤޤäTue,02 Dec,2008, <DEL>Don't learn INDEPPAIR in the middle of conversion. Patched by G-HAL, Sat,23 Aug,2008</DEL> */
  }
  return n;
}

#include <src-worddic/dic_ent.h>

/*
 * ΩΤ
 */
static void
proc_swap_candidate_indep(struct seg_ent *se)
{
  xstr *xs;
  xstr key;
  int i;
  int core_elm_idx;
  int res;
  struct cand_elm *core_elm;
  int	high_score;	/* Patched by G-HAL, Tue,02 Dec,2008 */

  core_elm_idx = se->cands[0]->core_elm_index;
  if (core_elm_idx < 0) {
    return ;
  }

  /* 0ܤθʸФ */
  core_elm = &se->cands[0]->elm[core_elm_idx];
  if (core_elm->nth < 0) {
    return ;
  }
  res = anthy_get_nth_dic_ent_str(core_elm->se,
				  &core_elm->str,
				  core_elm->nth,
				  &key);
  if (res) {
    return ;
  }

  /**/
  anthy_select_section(INDEPPAIR, 1);	/* Patched by G-HAL, Fri,17 Oct,2008 */
  xs = prepare_swap_candidate(&key);
  free(key.str);
  if (!xs) {
    return ;
  }

 #if 0		/* Patched by G-HAL, Tue,02 Dec,2008 */
  /*  -> xs ʤΤ xsθõ */
  for (i = 1; i < se->nr_cands; i++) {
    if (se->cands[i]->nr_words == se->cands[0]->nr_words &&
	se->cands[i]->core_elm_index == core_elm_idx) {
      xstr cand;
      res = anthy_get_nth_dic_ent_str(se->cands[i]->elm[core_elm_idx].se,
				      &se->cands[i]->elm[core_elm_idx].str,
				      se->cands[i]->elm[core_elm_idx].nth,
				      &cand);
      if (res == 0 &&
	  !anthy_xstrcmp(&cand, xs)) {
	free(cand.str);
	/* ߤĤΤǤθΥ򥢥å */
	se->cands[i]->score = se->cands[0]->score + 1;
	return ;
      }
      free(cand.str);
    }
  }
 #else
  /* ؽͳʳθǺǹʪõ */
  high_score = 0;
  for (i = 0; i < se->nr_cands; ++i) {
    if (0 == (CEF_ORIGIN_IS_LEARN & se->cands[i]->flag)) {
      high_score = se->cands[i]->score;
      break;
    }
  }

  /* ؽͳʳθФդؤԤ */
  for (; i < se->nr_cands; ++i) {
    if (CEF_ORIGIN_IS_LEARN & se->cands[i]->flag) {
      continue;
    }
    if ((se->cands[i]->nr_words == se->cands[0]->nr_words) &&
	(se->cands[i]->core_elm_index == core_elm_idx)
    ) {
      xstr cand;
      res = anthy_get_nth_dic_ent_str( se->cands[i]->elm[core_elm_idx].se,
				      &se->cands[i]->elm[core_elm_idx].str,
				      se->cands[i]->elm[core_elm_idx].nth,
				      &cand );
      if ((0 == res) && (0 == anthy_xstrcmp(&cand, xs))) {
	free(cand.str);
	if (se->cands[i]->score < high_score) {
	  se->cands[i]->score = high_score + 1;
	}
	break;
      }
      free(cand.str);
    }
  }
  return;
 #endif
}

/*
 * Ѵ¤٤֤Ǻͥθ
 */
void
anthy_proc_swap_candidate(struct seg_ent *seg)
{
  if (NULL == seg->cands) { /* ⤷ϳؽǡƤк */
    return;
  }

 #if 0		/* Patched by G-HAL, Tue,02 Dec,2008 */
  if (seg->cands[0]->score >= OCHAIRE_SCORE) {
    /* cands[0] ̤äƤ */
    return ;
  }
 #endif
  if (seg->cands[0]->flag & CEF_USEDICT) {
    return ;
  }
  /**/
  proc_swap_candidate_indep(seg);
}

/* 򴹤θŤȥä */
void
anthy_cand_swap_ageup(void)
{
 #if 0		/* Patched by G-HAL, Sat,23 Aug,2008 */
  if (anthy_select_section(INDEPPAIR, 0) == 0) {	/* Patched by G-HAL, Fri,17 Oct,2008 */
    anthy_truncate_section(MAX_INDEP_PAIR_ENTRY);
  }
 #endif
}
/* vim:ts=8 sw=2 nomodified:
 */
